// CBufferTest.cpp : Defines the entry point for the console application.
//
#include "stdio.h"
#include <string.h>
#include "global.h"
#include "buffer.h"

#define RFXML_BUFFER_SIZE  100

cBuffer_t       RxBuffer;
unsigned char   _RxBuffer [RFXML_BUFFER_SIZE];

typedef char* jalousieData_p;
typedef unsigned char   BOOL;
#define true   1
#define false  0


//-----------------------------------------------------------------------------
int RfXmlGetNumFromBuffer (cBuffer_p pBuffer, unsigned short iStart, char* tag1, char* tag2)
{
   int   pos1, pos2;
   int   l1;

   l1 = strlen (tag1);
   pos1 = cBufferStr (pBuffer, tag1, iStart, l1);
   if (pos1 >= 0)
   {
      pos2 = cBufferStr (pBuffer, tag2, pos1, strlen (tag2));
      if (pos2 >= 0)
      {
         char a [10];
         cBufferLookBuffer (pBuffer, a, pos1 + l1, pos2 - pos1 - l1);
         a [pos2 - pos1 - l1] = 0;
         l1 = atoi (a);
         return l1;
      }
   }

   return -1;
}   // RfXmlGetNumFromBuffer
//-----------------------------------------------------------------------------



//-----------------------------------------------------------------------------
BOOL jaousieDecodeData (jalousieData_p pJalousie, cBuffer_p pBuffer)
{
   int           pos1, pos2, pos3;
   char          text [20];
   
   // "Humbug <Info Room=1 Win=1><pos v=5><open v=0></Info>
   pos1 = cBufferStr (pBuffer, "<", 0, 1);
   if (pos1 >= 0)
   {
      pos2 = cBufferStr (pBuffer, ">", pos1, 1);
      pos3 = cBufferStr (pBuffer, " ", pos1, 1);
      if (pos2 < 0)
         pos2 = pos3;
      pos2 = min (pos2, pos3);
      if (pos2 >= 0)
      {
         text [0] = '<';
         text [1] = '/';
         cBufferLookBuffer (pBuffer, text + 2, pos1 + 1, pos2 - pos1 - 1);
         text [pos2 - pos1 - 1 + 2] = '>';
         text [pos2 - pos1 - 1 + 3] = 0;
         pos1 += strlen (text) - 1;
         pos2 = cBufferStr (pBuffer, text, pos1, strlen (text));
         if (pos2 >= 0)
         {
            pos3 = pos2 - 1;
            // Content is between pos1 and pos3
            
           
            return true;
         }
      }
   }
   
   return false;
}   // jaousieDecodeData
//-----------------------------------------------------------------------------



//-----------------------------------------------------------------------------
BOOL jaousieDecodeData2 (jalousieData_p pJalousie, cBuffer_p pBuffer)
{
   int   pos1, pos2;
   
   // "Humbug <Info Room=1 Win=1><pos v=5><open v=0></Info>
#define LEN   5
   pos1 = cBufferStr (pBuffer, "<Info", 0, LEN);
   if (pos1 >= 0)
   {
      pos1 += LEN + 1;
#undef LEN
#define LEN   7
      pos2 = cBufferStr (pBuffer, "</Info>", pos1, LEN);
      if (pos2 >= 0)
      {
         unsigned char cnt = pos2 + LEN;
         pos2--;
         // Content is between pos1 and pos2
         {
            // Room=
            int room = RfXmlGetNumFromBuffer (pBuffer, pos1, "Room=", " ");

            // Win=
            int win = RfXmlGetNumFromBuffer (pBuffer, pos1, "Win=", " ");

            // <pos v=x>
            int pos = RfXmlGetNumFromBuffer (pBuffer, pos1, "<pos v=", ">");

            // <open v=x>
            int isOpen = RfXmlGetNumFromBuffer (pBuffer, pos1, "<open v=", ">");

            if (room   >= 0 &&
                win    >= 0 &&
                pos    >= 0 &&
                isOpen >= 0)
            {
               // Process the values

            }

         }            
         // Remove the message and everything before from the buffer
         cBufferGetBuffer (pBuffer, NULL, cnt);
         return true;
      }
   }
   
   return false;
}   // jaousieDecodeData
//-----------------------------------------------------------------------------



//-----------------------------------------------------------------------------
int main(int argc, char* argv[])
{
   char string [100];
   unsigned short i;

	printf ("cBuffer_t test program!\n");

   cBufferInit (&RxBuffer, _RxBuffer, RFXML_BUFFER_SIZE);


   cBufferAddBuffer (&RxBuffer, (unsigned char *)"Hallo", 5);
   i = cBufferLookBuffer (&RxBuffer, string, 0, sizeof (string));
   string [i] = 0;
   printf ("%s length=%d\n", string, RxBuffer.len);

   cBufferAddBuffer (&RxBuffer, (unsigned char *)" Welt", 5);
   i = cBufferLookBuffer (&RxBuffer, string, 0, sizeof (string));
   string [i] = 0;
   printf ("%s length=%d\n", string, RxBuffer.len);

   cBufferAddBuffer (&RxBuffer, (unsigned char *)", Sonne", 7);
   i = cBufferLookBuffer (&RxBuffer, string, 0, sizeof (string));
   string [i] = 0;
   printf ("%s length=%d\n", string, RxBuffer.len);

   cBufferAddBuffer (&RxBuffer, (unsigned char *)" und Mond", 9);
   i = cBufferLookBuffer (&RxBuffer, string, 0, sizeof (string));
   string [i] = 0;
   printf ("%s length=%d\n", string, RxBuffer.len);

   printf ("cBufferCmp -> %d\n", cBufferCmp (&RxBuffer, "Hallo", 5));
   printf ("cBufferCmp -> %d\n", cBufferCmp (&RxBuffer, "Hall", 5));

   printf ("cBufferStr (...  0 ...) -> %d\n", cBufferStr (&RxBuffer, "Welt",  0, 4));
   printf ("cBufferStr (...  1 ...) -> %d\n", cBufferStr (&RxBuffer, "Welt",  1, 4));
   printf ("cBufferStr (...  6 ...) -> %d\n", cBufferStr (&RxBuffer, "Welt",  6, 4));
   printf ("cBufferStr (...  6 ...) -> %d\n", cBufferStr (&RxBuffer, "Welt",  6, 5));
   printf ("cBufferStr (...  7 ...) -> %d\n", cBufferStr (&RxBuffer, "Welt",  7, 4));
   printf ("cBufferStr (... 13 ...) -> %d\n", cBufferStr (&RxBuffer, "Welt", 13, 4));

   printf ("cBufferStr (...  NULL ...) -> %d\n", cBufferStr (&RxBuffer, NULL,  1, 4));


   cBufferFlush (&RxBuffer);
   strcpy (string, "Humbug <Info Room=1 Win=1><pos v=5><open v=0></Info>");
   cBufferAddBuffer (&RxBuffer, string, strlen (string));
   jaousieDecodeData  (NULL, &RxBuffer);
   jaousieDecodeData2 (NULL, &RxBuffer);
   
   
   cBufferFlush (&RxBuffer);
   strcpy (string, "Humbug <Info>Ein Text</Info>");
   cBufferAddBuffer (&RxBuffer, string, strlen (string));
   jaousieDecodeData (NULL, &RxBuffer);
   jaousieDecodeData2 (NULL, &RxBuffer);
   
   
   cBufferFlush (&RxBuffer);
   strcpy (string, "Humbug <Info>UNVOLLSTNDIG");
   cBufferAddBuffer (&RxBuffer, string, strlen (string));
   jaousieDecodeData (NULL, &RxBuffer);
   jaousieDecodeData2 (NULL, &RxBuffer);
   
   cBufferFlush (&RxBuffer);
   strcpy (string, "<OK/>");
   cBufferAddBuffer (&RxBuffer, string, strlen (string)+1);
   printf ("<OK/> -> %d\n", cBufferStr (&RxBuffer, "<OK/>", 1, 5));
   i= cBufferStr (&RxBuffer, "<OK/>", 0, 5);
   printf ("<OK/> -> %d\n", i);
   // Remove everything before incl. the handshake message from the buffer
   cBufferGetBuffer (&RxBuffer, NULL, i+5);
   i = cBufferLookBuffer (&RxBuffer, string, 0, sizeof (string));
   string [i] = 0;
   printf ("%s length=%d\n", string, RxBuffer.len);
   
   cBufferFlush (&RxBuffer);
   strcpy (string, "<OK/><Info Room=1 Win=1><pos v=5><open v=0></Info>");
   cBufferAddBuffer (&RxBuffer, string, strlen (string));
   jaousieDecodeData2 (NULL, &RxBuffer);

   i = cBufferLookBuffer (&RxBuffer, string, 0, sizeof (string));
   string [i] = 0;
   printf ("%s length=%d\n", string, RxBuffer.len);

   
   
   return 0;
}

