/**********************************************************************
@file       drawDigit.h

@brief      Draw a scalable 7-segment digit

-----------------------------------------------------------------------
@author  2010 Roman Steiger
         LeoTheLoewe [at] gmx [dot] de
-----------------------------------------------------------------------
Following compile flags are usable:


-----------------------------------------------------------------------
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
-----------------------------------------------------------------------
@History

1.00 10012010 RSt  Creation

@end
***********************************************************************/

/* ============================================================================
   Markus Fulde                                                      13.02.2011
   ----------------------------------------------------------------------------

   Der Sourcecode fr das WorkFrame fr die Betty stammt aus dem Forum
                        http://www.bettyhacks.com
   und wurde speziell fr das Projekt StarLight angepasst. Dabei wurden
   teilweise nicht bentigte Funktionen aus Grnden der Speichergre und
   Laufzeitoptimierung (z.B. beim Download der Firmware) komplett entfernt.

   Der in dieser Version nun vorliegende Programmcode dient zur Kommunikation
   der Betty ber Funk mit dem Master-Modul des StarLight-Projekts.

   Aufgrund der groen nderungen und Ergnzungen am Code stelle ich die SW
   nicht erneut ber das Bettyhacks-Forum zur Verfgung.
   Ich erhebe keinen Anspruch des Copyrights auf jegliche SW-Teile dieses
   Projekts. Das Copyright und die Rechte am Code verbleiben in uneingeschrnker
   Forum unter Einhaltung der GNU General Public License bestehen.

   Mge jeder der den Code verwenden kann genauso viel Freude haben wie ich
   hatte!
   ============================================================================
   Historie:
   13.02.2011  Version 1  Erste vollstndige Version nach Optimierung und
                          Einbindung in Gesamtprojekt.
   ============================================================================
*/

/* =================================== Includes ============================ */


/* ================== Datentypen und Variablendefinitionen ================= */

#ifndef __DRAW_DIGIT_H__
#define __DRAW_DIGIT_H__

#include "global.h"
#include "lcd.h"

#ifndef DIGIT_BAR_WIDTH
#define DIGIT_BAR_WIDTH   3
#endif

//      |<-   w   ->|
//      |           |
//      |d|1| w1|1|d|
//           ___      ______
//       _  |_a_|  _  _2_  ^
//      | |       | |      |
//      d |       | f  h1
//      |_|  ___  |_| ___  h
//       _  |_b_|  _   1
//      | |       | |
//      e |       | g      |
//      |_|  ___  |_|      v
//          |_c_|     _2____
//


/* ======================== Prototyping ==================================== */

//-----------------------------------------------------------------------------
void drawDigit (unsigned char x, unsigned char y,
                unsigned char w, unsigned char h,
                unsigned char digit, unsigned char d, unsigned char c, unsigned char m);
//-----------------------------------------------------------------------------


#endif   // #ifndef __DRAW_DIGIT_H__


/* =================================== Ende ================================ */



