/*
    fonty.h - drawing text & font handling
    Copyright (C) 2007  Ch. Klippel <ck@mamalala.net>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/* ============================================================================
   Markus Fulde                                                      13.02.2011
   ----------------------------------------------------------------------------

   Der Sourcecode fr das WorkFrame fr die Betty stammt aus dem Forum
                        http://www.bettyhacks.com
   und wurde speziell fr das Projekt StarLight angepasst. Dabei wurden
   teilweise nicht bentigte Funktionen aus Grnden der Speichergre und
   Laufzeitoptimierung (z.B. beim Download der Firmware) komplett entfernt.

   Der in dieser Version nun vorliegende Programmcode dient zur Kommunikation
   der Betty ber Funk mit dem Master-Modul des StarLight-Projekts.

   Aufgrund der groen nderungen und Ergnzungen am Code stelle ich die SW
   nicht erneut ber das Bettyhacks-Forum zur Verfgung.
   Ich erhebe keinen Anspruch des Copyrights auf jegliche SW-Teile dieses
   Projekts. Das Copyright und die Rechte am Code verbleiben in uneingeschrnker
   Forum unter Einhaltung der GNU General Public License bestehen.

   Mge jeder der den Code verwenden kann genauso viel Freude haben wie ich
   hatte!
   ============================================================================
   Historie:
   13.02.2011  Version 1  Erste vollstndige Version nach Optimierung und
                          Einbindung in Gesamtprojekt.
   ============================================================================
*/

/* =================================== Includes ============================ */


/* ================== Datentypen und Variablendefinitionen ================= */

#ifndef FONTY_H
#define FONTY_H

#define SMALLFONT       0
#define DOUBLEFONT      1
#define BOLDFONT        2
#define BOLDDOUBLEFONT  3
#define SMOOTHFONT      4

#define SMALLFONT_HEIGHT       8
#define DOUBLEFONT_HEIGHT      16
#define BOLDFONT_HEIGHT        8
#define BOLDDOUBLEFONT_HEIGHT  16
#define SMOOTHFONT_HEIGHT      16

#define tabstep            24

unsigned char activefont;

unsigned short get_stringwidth (const char *st);
unsigned short get_stringheight (const char *st);


/* ======================== Prototyping ==================================== */

void set_font     (unsigned char f);
void draw_char    (unsigned char x, unsigned char y, unsigned char ch, unsigned char c, unsigned char m);
void draw_string  (unsigned char x, unsigned char y, char *st, unsigned char c, unsigned char m);
void draw_hexC    (unsigned char x, unsigned char y, const unsigned char v, unsigned char c, unsigned char m);
void draw_hexS    (unsigned char x, unsigned char y, const unsigned short v, unsigned char c, unsigned char m);
void draw_hexW    (unsigned char x, unsigned char y, const unsigned long v, unsigned char c, unsigned char m);

void draw_numU    (unsigned char x, unsigned char y, const unsigned long v, unsigned char z, unsigned char c, unsigned char m);

#endif


/* =================================== Ende ================================ */


