/*
    global.h
    Copyright (C) 2007  Colibri <colibri_dvb@lycos.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/* ============================================================================
   Markus Fulde                                                      13.02.2011
   ----------------------------------------------------------------------------

   Der Sourcecode fr das WorkFrame fr die Betty stammt aus dem Forum
                        http://www.bettyhacks.com
   und wurde speziell fr das Projekt StarLight angepasst. Dabei wurden
   teilweise nicht bentigte Funktionen aus Grnden der Speichergre und
   Laufzeitoptimierung (z.B. beim Download der Firmware) komplett entfernt.

   Der in dieser Version nun vorliegende Programmcode dient zur Kommunikation
   der Betty ber Funk mit dem Master-Modul des StarLight-Projekts.

   Aufgrund der groen nderungen und Ergnzungen am Code stelle ich die SW
   nicht erneut ber das Bettyhacks-Forum zur Verfgung.
   Ich erhebe keinen Anspruch des Copyrights auf jegliche SW-Teile dieses
   Projekts. Das Copyright und die Rechte am Code verbleiben in uneingeschrnker
   Forum unter Einhaltung der GNU General Public License bestehen.

   Mge jeder der den Code verwenden kann genauso viel Freude haben wie ich
   hatte!
   ============================================================================
   Historie:
   13.02.2011  Version 1  Erste vollstndige Version nach Optimierung und
                          Einbindung in Gesamtprojekt.
   ============================================================================
*/


/* =================================== Includes ============================ */


/* ================== Datentypen und Variablendefinitionen ================= */


#ifndef GLOBAL_H
#define GLOBAL_H


// ----- Globale StarLight Variablen -----

// Zustnde definieren
#define  FKT_STATUS_AUS             0x00
#define  FKT_STATUS_EIN             0x01


//Uncomment if you want compile with demo sound
//#define WITH_SOUND

// Set appropriate feature flags
#define FF_UART_REDIRECT      0
#define FF_LARGE_IDLE_CLOCK   1
#define FF_LARGE_MENU         1
#define FF_ICON_TRANSPARENT   1   // enable 3 BitPerPixel icons support
#define FF_TEST_ICON          1   // enable Test dialog

typedef unsigned char  BOOL;
typedef unsigned char  BYTE;
typedef unsigned short WORD;
typedef unsigned long  DWORD;

#define false   0
#define true    1

#ifndef NULL
#define NULL    0
#endif

#define max(a,b)            (( (a) > (b)) ? (a) : (b))
#define min(a,b)            (( (a) < (b)) ? (a) : (b))

#ifndef _BV
#define _BV(bit)   (1 << (bit))
#endif

#define NUM_OF_ELEMENTS(x)   sizeof(x)/sizeof(x[0])

#define    SPEED_30    0
#define    SPEED_60    1

// Execute code in locked sequence
#define INT_LOCK(x)     {unsigned cpsr = disableIRQ (); {x;} restoreIRQ (cpsr);}

/** Let the LPC2200 sleep until the next IRQ
*
* This function tries to enter the sleep mode and stays
* there until the next interrupt wakes up the CPU.
* If that is not possible, the function returns immediately.
*/
extern void cpu_idle (void);

#define SYS_NOIDLE   0x08   // No Idle Mode
#define SYS_NOPDOWN  0x10   // No Power Down
#define SYS_IR       0x20
#define SYS_KEY      0x40
#define SYS_TURBO    0x80

#include <stdio.h>

//#ifndef WIN32
//#define printd(...)        printf(__VA_ARGS__)
//#endif

#ifndef __MAIN_C__
extern char sysInfo;
#endif /* __MAIN_C__ */

extern unsigned char debugoutbuf [];

#define PCON_IDLE    0x01
#define PCON_PDOWN   0x02


/* ======================== Prototyping ==================================== */


/*
void *memcpy (void *dest,void *src,int count);
int memcmp (const void * cs,const void * ct,int count);
*/

unsigned char GetHWversion (void);
int puts (const char* string);

void drawMainscreen (void);

#endif


/* =================================== Ende ================================ */


